#!/usr/bin/env python

# This code needs to be rewritten in a cleaner way, but it works alright now
# TODO: Add a context menu with copy and paste to the VTE

import sys, os, errordb

cmd = 'startdosp'
if len(sys.argv) > 1:
    cmd = sys.argv[1]
if not '-silent' in sys.argv: print 'Running with', cmd
try:
  import gtk
  import pango
except:
  print >> sys.stderr, "You need to install the python gtk and pango bindings"
  sys.exit(1)
  
# import vte
try:
  import vte
except:
  error = gtk.MessageDialog (None, gtk.DIALOG_MODAL, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,
    'You need to install python bindings for libvte')
  error.run()
  sys.exit (1)
  
  
  
import dbus
import dbus.service
import gobject

from dbus.mainloop.glib import DBusGMainLoop
from dbus.service import method, signal

DBusGMainLoop(set_as_default=True)

DBUS_BUSNAME = "org.dosprompt.DOSprompt"
DBUS_IFACE = 'org.dosprompt.DOSpromptInterface'
DBUS_PATH = '/org/dosprompt/DOSprompt/DOSprompt'

class ExampleObject(dbus.service.Object):

    @method(dbus_interface=DBUS_IFACE, in_signature="s")
    def set_title(self, title):
        window.set_title(title)
        varies.get('title').update(title)
        print 'title set to', title

    @signal(dbus_interface=DBUS_IFACE, signature="a{ss}")
    def ExampleSignal(self, info):
        pass

session_bus = dbus.SessionBus()
busname = dbus.service.BusName(DBUS_BUSNAME, bus=session_bus)
eo = ExampleObject(object_path=DBUS_PATH, bus_name=busname)

loop = gobject.MainLoop()

def start():
    loop.run()
    
def stop():
    loop.quit()
  
def quit():
  x = v.get_child_exit_status()
  if x != 0:
      error = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, 'DOSprompt exited with errorlevel %s, (%s)' % (str(x), errordb.errnos.get(x, 'Unknown Error')))
      error.run()
      sys.exit(1)
  try: gtk.main_quit()
  except: sys.exit()

import varies
varies.var('title', 'DOSprompt')


if __name__ == '__main__':
  v = vte.Terminal ()
  color = gtk.gdk.Color('#FFFFFF')

  v.set_font_from_string_full('Monospace', vte.ANTI_ALIAS_FORCE_ENABLE)
  v.connect ("child-exited", lambda term: quit())
  v.set_cursor_shape(vte.CURSOR_SHAPE_UNDERLINE)
  v.fork_command(cmd)
  v.set_color_background(color)
  vis = gtk.gdk.Visual(24, gtk.gdk.VISUAL_TRUE_COLOR)
  colormap = gtk.gdk.Colormap(vis, 24)
  v.set_colormap(colormap)
  window = gtk.Window()
  window.set_title('DOSprompt')
  window.add(v)
  window.connect('delete-event', lambda window, event: quit())
  window.show_all()

  start()
  gtk.main()

