#!/usr/bin/env python
# this is a dosprompt plugin that sets the cli colors just like the windows color command
# The module loader
def my_import(name):
    mod = __import__(name)
    components = name.split('.')
    for comp in components[1:]:
        mod = getattr(mod, comp)
    return mod
    
    
def main(line, path, config):
    lp = my_import("lang." + config.lang_pack + '.text').color()
    if len(line) > 1:
        
        if len(line[1]) == 2 and not line[1] == '/?':
            cf = open(path + '/config.py', 'r')
            cfdata = cf.read()
            cf.close()
            cfw = open(path + '/config.py', 'w') # reopen the file in overwrite mode
            cfw.write(cfdata.replace('fg_color = ' + str(config.fg_color), 'fg_color = ' + line[1][1]).replace('bg_color = ' + str(config.bg_color), 'bg_color = ' + line[1][0]))
        elif line[1] == '/?':
            print lp.get('help')
