# this is a special plugin for performing special DOSprompt operations
# The module loader
import os, config, common
lp = common.my_import("lang." + config.lang_pack + '.text').main()
__docstring__ = lp.get('dosp_help')

def main(line, cd, config):
    if len(line) > 1:
        if line[1] == 'lsplugins':
            'this function will at some point replace the one built into dosprompt'
        elif line[1] == 'plugindex':
            'this function will at some point replace the one built into dosprompt'
        elif line[1] == 'developer' and len(line) > 2:
            #this function\'s job is to set up a more developer-ready environment (or unset it)
            print 'Turning %s developer mode in %s/config.py (don\'t worry if it is already %s)' % (line[2], cd, line[2])
            cf = open(cd + '/config.py', 'r')
            cfdata = cf.read()
            cf.close()
            if line[2] == 'on':
                cfw = open(cd + '/config.py', 'w') # reopen the file in overwrite mode
                cfw.write(cfdata.replace('developer_mode = ' + str(config.developer_mode), 'developer_mode = True'))
                print "Would you like to set up a git repository of DOSprompt?"
                yn = raw_input("[Y/n]")
                if yn.lower() in lp.get('yesses'):
                    print 'Heehee! Sorry, that is not implemented yet :)'
                    os.system(cd + "/setup_git.sh")
                else: 
                    print ""
            elif line[2] == 'off':
                cfw = open(cd + '/config.py', 'w') # reopen the file in overwrite mode
                cfw.write(cfdata.replace('developer_mode = ' + str(config.developer_mode), 'developer_mode = False'))
            return
        elif line[1] == 'developer' and len(line) == 2:
            return "Please trigger developer mode with 'dosp developer [on/off]' or run 'dosp mkplugin' to get started with a plugin"
        elif line[1] == 'mkplugin' and config.developer_mode:
            if len(line) > 2:
                print 'Checking validity of %s' % line[2]
                if '_' in line[2] or '/' in line[2] or '\\' in line[2] or '.' in line[2] or line[2] + '.py' in os.listdir(cd + '/plugins/') or line[2] in os.listdir(cd + '/plugins/'):
                    return 'Invalid name! Name connot contain _./ or \\ and it cannot be an existing plugin'
                else: print 'Good name!'
                
                f = open(cd + '/plugins/' + line[2] + '.py', 'w')
                f.write('# add imports here\n\n# the main function\ndef main(line, ld, config): # command line (list), library directory (where dosprompts files are), config (the config module)\n    return ("Testing testing 1 2 3!", 0)\n')
                f.close()
                
                return 'All done, run \'dosp plugindex\', and check out %s/plugins/%s.py' % (cd, line[2])
                
            else: 
                return lp.get('dosp_mkplugin_help')
    return lp.get('dosp_help')
    
